// ------------------------- * common EQ page code * -------------------------

function eqPageBandCreate(f, x, y, props)
{
	var obj={};

	obj.line =gui.newPicture(f, x, y+6, 80,  2, "img/hline.png");
	obj.title=gui.newLabel(f, x+28, y, 24, 14, '', prop_value);
	obj.title.setProps({bgcolor: color.dblue});
	obj.title.setText(props.title);
// 2 knobs with labels and values
	obj.gain=knobCreate(f, x   , y+17, 40, "GAIN");
	obj.freq=knobCreate(f, x+40, y+17, 40, "FREQ");
	obj.v_gain=0;
	obj.v_freq=0;
	obj.a_gain=0;
	obj.a_freq=0;

	obj.t_gain=props.t_gain;
	obj.t_freq=props.t_freq;
	obj.name  =props.title;
	obj.frange=props.frange;

	obj.focus=function(on)
	{
		var prop=on?propAct:propOff;
		var idx=on?1:0;
		var kidx=on?2:0;

		this.line.setIndex(-1, idx);
		this.title.setProps(prop);
		this.gain.val.setProps(prop);
		this.gain.lbl.setProps(prop);
		this.gain.knob.setIndex(kidx);
		this.freq.val.setProps(prop);
		this.freq.lbl.setProps(prop);
		this.freq.knob.setIndex(kidx);
	}

	return obj;
}

function eqPageCreate(props)
{
	var p={id: props.id};
	var f, eq_fr;

// ch.options container frame
	p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
	p.frame.hide();
	f=p.frame;

	p.title={};
	p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
	p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);

	if(props.hppage)
	{
		gui.newFrame(f, 150, 44, 144, 12, "img/monitor_options.png");
		p.title.label.setText("H/P PROCESS");
		p.hppage=true;
		p.maintag='mCRHP';
	}
	else
	{
		gui.newFrame(f, 150, 60, 145, 12, "img/channel_options.png");
		p.hppage=false;
		p.maintag='mCHxx';
	}

	eq_fr=gui.newFrame(f, 48, 131, 356, 219, "img/eq_bg.png");
	p.on =gui.newLabel(eq_fr, 200, 10, 50, 14, '', prop_value_yellow);
	var l=gui.newLabel(eq_fr, 60, 10, 100, 14, '', prop_value);
	l.setText("EQUALIZER");

// graph
	p.graph=gui.newEq(eq_fr, 30, 32, 276, 82, "");
	eqSetLogFreq(p.graph, 1, 260, 61, 87);
	p.graph.setdB(1, 80, 27, 26/15);

// band controls
	p.b=[];
	p.b[0]=eqPageBandCreate(eq_fr,  28, 143, {title:"LO" , t_gain:'wEQLG', t_freq:'wEQLF', frange: eq_range.f_lo });
	p.b[1]=eqPageBandCreate(eq_fr, 136, 143, {title:"MID", t_gain:'wEQMG', t_freq:'wEQMF', frange: eq_range.f_mid});
	p.b[2]=eqPageBandCreate(eq_fr, 244, 143, {title:"HI" , t_gain:'wEQHG', t_freq:'wEQHF', frange: eq_range.f_hi });

	p.b[0].shelf=gui.newPicture(eq_fr,   3, 175, 23, 20, "img/shelf_edit_lo.png");
	p.b[2].shelf=gui.newPicture(eq_fr, 329, 175, 23, 20, "img/shelf_edit_hi.png");

	p.eqac=false; p.eqlm=false; p.eqhm=false;

	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.b) this.b[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.b) this.b[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "LO GAIN", push: "BYPASS/\nACTIVE", enter: true},
		{enabled: true, rot: "LO FREQ"},
		{enabled: true, rot: "MID GAIN"},
		{enabled: true, rot: "MID FREQ"},
		{enabled: true, rot: "HI GAIN"},
		{enabled: true, rot: "HI FREQ", push: "HI SHELF"}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "GAIN", updn: true},
		{enabled: true,  rot: "FREQ", push: "BYPASS/\nACTIVE", jog: true, enter: true},
		{enabled: true,  rot: "FUNCTION", push: "EXIT", ltrt: true}
	];

// event functions
	p.onSoftKnobRot =eqPageOnSoftKnobRot;
	p.onSoftKnobDown=eqPageOnSoftKnobDown;
	p.onSoftKnobUp  =eqPageOnSoftKnobUp;
	p.onIndiEx=eqPageOnIndi;

	pages[props.id]=p;
	return p;
}

function eqPageOnIndi(chmsg)
{
	var n, band;
	var changed=false;

	for(n=0; n<3; n++)
	{
		band=this.b[n];
		if(band.t_gain in chmsg)
		{
			band.v_gain=chmsg[band.t_gain];
			band.a_gain=knobSetValue(band.gain, band.v_gain, eq_range.gain);
			sknobsSetOne(n*2, {angleNrm: band.a_gain});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: band.a_gain});
			changed=true;
		}
		if(band.t_freq in chmsg)
		{
			band.v_freq=chmsg[band.t_freq];
			band.a_freq=knobSetFreq(band.freq, band.v_freq, band.frange);
			sknobsSetOne(n*2+1, {angleNrm: band.a_freq});
			if(this.focus==n)
				sknobsSetOne(7, {angleNrm: band.a_freq});
			changed=true;
		}
	}
	if('bEQAC' in chmsg)
	{
		this.eqac=(chmsg.bEQAC==1); // 1 - EQ on
		this.on.setText(this.eqac?"ACTIVE":"BYPASS");
		changed=true;
	}
	if('bEQLM' in chmsg)
	{
		this.eqlm=(chmsg.bEQLM==1); // 1-shelf, 2-pass
		this.b[0].shelf.setIndex(this.eqlm?0:1);
		changed=true;
	}
	if('bEQHM' in chmsg)
	{
		this.eqhm=(chmsg.bEQHM==1); // 1-shelf, 2-pass
		this.b[2].shelf.setIndex(this.eqhm?0:1);
		sknobsSetOne(5, {push: this.eqhm?"SHELF":"PEAK"});
		if(this.focus==2)
			sknobsSetOne(6, {push: this.eqhm?"HI SHELF":"HI PEAK"});
		changed=true;
	}

	if(changed)
	{
		if(this.eqac)
			this.graph.setParams(this.b[0].v_freq, this.b[1].v_freq, this.b[2].v_freq, this.b[0].v_gain/10, this.b[1].v_gain/10, this.b[2].v_gain/10, this.eqlm, this.eqhm);
		else
			this.graph.setParams(0, 0, 0, 0, 0, 0, false, false);
	}
}

function eqPageOnSoftKnobRot(idx, delta)
{
	var msg={id:'WRIN'};
	var n, band;

	idx--; // fixme

	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 2));
		sknobsSetOne(8, {angleNrm: this.focus/2});
		band=this.b[this.focus];
		sknobsSetOne(6, {enabled: true, rot: band.name+" GAIN", push:this.focus==2?(this.eqhm?"HI SHELF":"HI PEAK"):null, angleNrm: band.a_gain});
		sknobsSetOne(7, {enabled: true, rot: band.name+" FREQ", angleNrm: band.a_freq});
		return;
	}

	if(idx>=0 && idx<=5)
		n=idx>>1;
	else
		n=this.focus;

	if(n in this.b)
	{
		band=this.b[n];

		if(idx&1) // Frequency
		{
			msg[band.t_freq]=clamp(band.v_freq+delta*band.frange.step, band.frange.min, band.frange.max);
		}
		else // Gain
		{
			msg[band.t_gain]=clamp(band.v_gain+delta*eq_range.gain.step, eq_range.gain.min, eq_range.gain.max);
			if(n==0) msg.bEQLM=msg.wEQLG<0?1:2; // low mode is automatic: FIXME: this probably should be done @ engine side
		}
		host.sendNestCmsg(this.maintag, msg);
	}
}
function eqPageOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 8:
	case 1: // active / bypass
		host.sendNestCmsg(this.maintag, {id:"WRIN", bEQAC: this.eqac?0:1});
		break;
	case 7:
		if(this.focus!=2) return;
		/* fall through */
	case 6: // hi shelf
		host.sendNestCmsg(this.maintag, {id:"WRIN", bEQHM: this.eqhm?2:1});
		break;
	}
}
function eqPageOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 9: // Combo3
		if(('channel' in this) && this.channel!=null)
			chSwitchToPage(this); // will effectively go back to chopt page
		else
			closePage(this, null);
		break;
	}
}

// ------------------------ channel eq page ------------------------

function cheqPageCreate()
{
	var p=eqPageCreate({id:"cheq", hppage: false});
	p.onOpen =cheqOnOpen;
	p.onClose=cheqOnClose;
	p.onIndi =cheqIndi;
}

function cheqOnOpen(channel_nr)
{
	if(channel_nr==null) return;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	this.channel=channel_nr;
	this.maintag=txtChn[channel_nr];
	this.title.label.setText(host.sprintf("CHANNEL %02d", channel_nr));

	var rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ",
		bEQTY:0, bEQAC:0, bEQHM:0, bEQLM:0, bEQHF:0,
		bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0
	});
	if(rmsg!=null)
	{
		this.onIndi(rmsg);

	// register receive msg handlers
		pages.rxHandlersCh[this.channel].cheq=this;
		mod.setChnKeyLed(channel_nr, keys.ChnOptions, 255);
		mod.setMasterKeyLed(keys.MstChnEq, 255);
	}
}
function cheqOnClose()
{
	sknobsHide();

//delete receive msg handlers
	delete pages.rxHandlersCh[this.channel].cheq;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setMasterKeyLed(keys.MstChnEq, 0);
}
function cheqIndi(chmsg)
{
	this.onIndiEx(chmsg);
}

// ------------------------ global hpeq page ------------------------
function hpeqPageCreate()
{
	var p=eqPageCreate({id:"hpeq", hppage: true});
	p.onOpen =hpeqOnOpen;
	p.onClose=hpeqOnClose;
	p.onIndi =hpeqIndi;
}

function hpeqOnOpen(channel_nr)
{
	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

// can not use host.sendNestCmsgRq as it will remove "mCRHP" from rmsg. And it is needed for onIndi.
	var rmsg=host.sendCmsgRq({id:"NEST", mCRHP:{id:"READ",
		bEQTY:0, bEQAC:0, bEQHM:0, bEQLM:0, bEQHF:0,
		bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0
	}});
	if(rmsg!=null)
	{
		this.onIndi(rmsg);

	// register receive msg handlers
		pages.rxHandlersGlobal.hpeqIndi=hpeqIndi;
		mod.setMasterKeyLed(keys.MstMonOpt, 255);
		mod.setMasterKeyLed(keys.CmbMonOpt, 255);
	}
}
function hpeqOnClose()
{
	sknobsHide();

//delete receive msg handlers
	delete pages.rxHandlersGlobal.hpeqIndi;

	mod.setMasterKeyLed(keys.MstMonOpt, 0);
	mod.setMasterKeyLed(keys.CmbMonOpt, 0);
}
function hpeqIndi(msg)
{
	var p=pages.hpeq;
	if('mCRHP' in msg)
		p.onIndiEx(msg.mCRHP);
}
