// ------------------------- * network setup * -------------------------
const netSetupTitles=
[
	'ELEMENT IP ADDRESS',
	'SUBNET MASK',
	'GATEWAY IP ADDRESS',
	'ENGINE IP ADDRESS',
	'1st NTP SERVER IP ADDRESS',
	'2nd NTP SERVER IP ADDRESS',
	'WEB PAGE USER PASSWORD'
];
const ipActions=
[
	"SAVE",
	"UNDO",
	"REBOOT"
];
const ipActionToKnob=[5,3,4];
const clrFG=color.ltblue, clrBG=color.dblue, clrHL=color.yellow;

function ipPageCreate()
{
	pages.ip=new NetSetupPage();
}

/*
** NetSetupPage
*/
function NetSetupPage()
{
	// private data:
	var itemLabel=[], itemBox=[], itemIP=[];
	var itemIPvalue=[];
	var curItem=-1, curPos=-1;
	var numeric=false;
	var lastItemIdx = netSetupTitles.length - 1;

	// public:
	this.id = "ip";
	this.frame=null;

	this.action=0;

// softknobs
	this.sknobs6=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", jog: true, enter: true},
		{enabled: false},
		{enabled: true, push: "UNDO"},
		{enabled: true, push: "REBOOT"},
		{enabled: true, push: "SAVE"},
		{enabled: true, push: "EXIT"}
	];
	this.sknobs3=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", jog: true, enter: true},
		{enabled: true, rot: "ACTION", push: "SAVE"},
		{enabled: true, push: "EXIT"}
	];

	// initialize, build screens
	init(this);

	this.onOpen = function(channel_nr)
	{
		sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);
		sknobsSetOne(0, {angleNrm: curItem/lastItemIdx});
		sknobsSetOne(6, {angleNrm: curItem/lastItemIdx});
		sknobsSetOne(7, {angleNrm: 0});
		this.action=0;

		readNetConfig();
		selectItem(0);
		selectPos(-1);
	};
	this.onClose = function()
	{
		sknobsHide();
	};
	this.onNumpadDown = function(key)
	{
		if(curPos!=-1)
		{
			if(key>=0 && key<=10)	// 10=='*': delete last digit
				numIP(key);
			else if(key==11) // 11=='#': go right
				this.onLtRt(1);
		}
	};
	this.onUpDn=function(delta)
	{
		if(delta<0)
		{
			if(curPos==-1)
			{
				if(curItem>0) selectItem(curItem-1);
			}
			else
				incIP(1);
		}
		else if(delta>0)
		{
			if(curPos==-1)
			{
				if(curItem<lastItemIdx) selectItem(curItem+1);
			}
			else
				incIP(-1);
		}
	};
	this.onLtRt = function(delta)
	{
		if(delta<0 && curPos>=0)
			selectPos(curPos-1);
		else if(delta>0 && curPos<=3)
			selectPos(curPos==3?-1:curPos+1);
	};
	this.onSoftKnobDown=function(idx)
	{
		if(idx==8)
			idx=ipActionToKnob[this.action];
		switch(idx)
		{
		case 1:
		case 7:
			this.onLtRt(1);
			break;
		case 3:
			readNetConfig();
			selectItem(0);
			selectPos(-1);
			break;
		case 4:
		// reboot
			host.reboot();
			break;
		case 5:
		// save
			writeNetConfig();
			readNetConfig();
			break;
		}
	};
	this.onSoftKnobUp = function(idx)
	{
		switch(idx)
		{
		case 6:
		case 9:
			closePage(this, null);
			break;
		}
	};
	this.onSoftKnobRot = function(idx, delta)
	{
		var aname;

		switch(idx)
		{
		case 1:
		case 7:
			if(curPos==-1)
			{
				if(delta<0 && curItem>0)
					selectItem(curItem-1);
				else if(delta>0 && curItem<lastItemIdx)
					selectItem(curItem+1);
			}
			else
				incIP(delta<0?-1:1);
			break;
		case 8:
			this.action=clamp(this.action+delta, 0, 2);
			aname=ipActions[this.action];
			sknobsSetOne(7, {angleNrm:this.action/2, push: aname});
			break;
		}
	};

	// private functions:
	function init(p)
	{
		var n, m, f;

	// ch.options container frame
		p.frame=gui.newFrame(mainframe, 0, 0, 463, 507, '');
		p.frame.hide();
		f=p.frame;

		gui.newFrame(f, 155, 60, 135, 12, "img/global_options.png");
		p.title={};
		p.title.frame=gui.newFrame(f, 174, 84, 100, 26, "img/chopt_title.png");
		p.title.label=gui.newLabel(p.title.frame, 5, 6, 90, 15, '', prop_channel);
		p.title.label.setText("SET IP ADDRESS");

	// ip configuration menu
		var fr = gui.newFrame(f, 49, 131, 353, 329, "img/mst_ip_bg.png");
		for(n=0; n<=lastItemIdx; n++)
		{
			itemLabel[n]=gui.newLabel(fr, 30, 79+30*n, 140, 14, '', prop_value_left);

			if(n<lastItemIdx)
			{
				itemBox[n]=gui.newFrame(fr, 172, 79+30*n, 146, 15, "img/ip_box.png");
				itemIP[n]=[];
				for(m=0; m<4; m++)
				{
					itemIP[n][m]=gui.newLabel(itemBox[n], 1+39*m, 1, 27, 13, '', prop_value);
					itemIP[n][m].setProps({bgcolor:clrBG});
				}
			}
			else
			{
				itemBox[n]=gui.newFrame(fr, 172, 79+30*n, 63, 15, "img/pass_box.png");
				itemIP[n]=[];
				for(m=0; m<4; m++)
				{
					itemIP[n][m]=gui.newLabel(itemBox[n], 1+16*m, 1, 13, 13, '', prop_value);
					itemIP[n][m].setProps({bgcolor:clrBG});
					itemIP[n][m].setText("");
				}
			}
		}
	}

	function dasmIP(ip)
	{
		return [ip&0xFF, (ip>> 8)&0xFF, (ip>>16)&0xFF, (ip>>24)&0xFF];
	}

	function asmIP(ip)
	{
		return ip[0]|(ip[1]<<8)|(ip[2]<<16)|(ip[3]<<24);
	}

	function setItemIP(index, ip)
	{
		var n;

		for(n=0; n<4; n++)
			itemIP[index][n].setText(host.sprintf("%3d", ip[n]));
	}

	function readNetConfig()
	{
		var netconf=host.getNetSetup();
		var n;

		itemIPvalue[0]=dasmIP(netconf.ipaddr);
		itemIPvalue[1]=dasmIP(netconf.netmask);
		itemIPvalue[2]=dasmIP(netconf.gateway);
		// default values if no response from ACL
		itemIPvalue[3]=dasmIP(0);
		itemIPvalue[4]=dasmIP(0);
		itemIPvalue[5]=dasmIP(0);
		// read from ACL
		var rmsg=host.sendNestCmsgRq('mCONF', {id:"READ", bENGA:0, bNTPA:0, bNTPB:0, bNTPN:0});
		if(rmsg!=null)
		{
			if('dENGA' in rmsg) itemIPvalue[3]=dasmIP(rmsg.dENGA);
			if('dNTPA' in rmsg) itemIPvalue[4]=dasmIP(rmsg.dNTPA);
			if('dNTPB' in rmsg) itemIPvalue[5]=dasmIP(rmsg.dNTPB);
			if('bNTPN' in rmsg)
			{
			// mark active NTP server
				if(rmsg.bNTPN==1)
					itemLabel[4].setText(netSetupTitles[4]+"  *");
				else if(rmsg.bNTPN==2)
					itemLabel[5].setText(netSetupTitles[5]+"  *");
			}
		}

		itemIPvalue[6] = [];
		for(n=0; n<4; n++)
		{
			itemIPvalue[6][n]=0;
			itemIP[6][n].setText(curItem==6?"0":"");
		}

		for(n=0; n<=lastItemIdx; n++)
		{
			if (n<lastItemIdx)
			setItemIP(n, itemIPvalue[n]);
			itemLabel[n].setText(netSetupTitles[n]);
		}
	}

	function writeNetConfig()
	{
		var netconf={};

		netconf.ipaddr=asmIP(itemIPvalue[0]);
		netconf.netmask=asmIP(itemIPvalue[1]);
		netconf.gateway=asmIP(itemIPvalue[2]);
		host.setNetSetup(netconf);
	// engine and ntp ip
		host.sendNestCmsg('mCONF', {id:"WRNI", dENGA:asmIP(itemIPvalue[3]), dNTPA:asmIP(itemIPvalue[4]), dNTPB:asmIP(itemIPvalue[5])});

		var new_pass = "";
		var new_pass_set = false;
		var m;
		for(m=0; m<4; m++)
		{
			if (itemIPvalue[6][m]!=0) new_pass_set = true;
			new_pass += host.sprintf("%1d", itemIPvalue[6][m]);
		}
		if(new_pass_set) /* change HTTP access password */
			host.httpSetPassword(new_pass);
	}

	function selectItem(index)
	{
		var n;

		if(curItem==index) return;

		// deselect previous
		if(curItem>=0 && curItem<=lastItemIdx)
		{
			itemLabel[curItem].setProps({color:clrFG});
			itemBox[curItem].setBg( (curItem<lastItemIdx) ? "img/ip_box.png" : "img/pass_box.png" );
			for(n=0; n<4; n++)
				itemIP[curItem][n].setProps({color:clrFG, bgcolor:clrBG});
			if (curItem==6 && itemIPvalue[curItem][0]==0 && itemIPvalue[curItem][1]==0 && itemIPvalue[curItem][2]==0 && itemIPvalue[curItem][3]==0)
				for(n=0; n<4; n++)
					itemIP[curItem][n].setText("");
		}

		// select next
		if(index>=0 && index<=lastItemIdx)
		{
			itemLabel[index].setProps({color:clrHL});
			itemBox[index].setBg( (index<lastItemIdx) ? "img/ip_boxs.png" : "img/pass_boxs.png" );
			for(n=0; n<4; n++)
				itemIP[index][n].setProps({color:clrHL, bgcolor:clrBG});
			if (index==6 && itemIPvalue[index][0]==0 && itemIPvalue[index][1]==0 && itemIPvalue[index][2]==0 && itemIPvalue[index][3]==0)
				for(n=0; n<4; n++)
					itemIP[index][n].setText("0");
		}
		curItem=index;
		sknobsSetOne(0, {angleNrm: curItem/lastItemIdx});
	}

	function selectPos(index)
	{
		if(curPos==index) return;

		// deselect previous
		if(curPos>=0 && curPos<=4)
			itemIP[curItem][curPos].setProps({color:clrHL, bgcolor:clrBG});

		// select next
		if(index>=0 && index<=4)
			itemIP[curItem][index].setProps({color:clrBG, bgcolor:clrHL});

		numeric=false;
		curPos=index;
	}

	function incIP(step)
	{
		var val;

		if(curItem<lastItemIdx)
		{
			numeric=false;
			val=itemIPvalue[curItem][curPos]+step;
			if(val>=0 && val<=255)
			{
				itemIPvalue[curItem][curPos]=val;
				itemIP[curItem][curPos].setText(host.sprintf("%3d", val));
				itemLabel[curItem].setText(netSetupTitles[curItem]+' *');
			}
		}
		else
		{
			numeric=false;
			val=itemIPvalue[curItem][curPos]+step;
			if(val>=0 && val<=9)
			{
				itemIPvalue[curItem][curPos]=val;
				itemIP[curItem][curPos].setText(host.sprintf("%1d", val));
				if(itemIPvalue[curItem][0]==0 && itemIPvalue[curItem][1]==0 && itemIPvalue[curItem][2]==0 && itemIPvalue[curItem][3]==0)
					itemLabel[curItem].setText(netSetupTitles[curItem]);
				else
					itemLabel[curItem].setText(netSetupTitles[curItem]+' *');
			}
		}
	}

	function numIP(num)
	{
		var val;

		if(!numeric)
		{
			val=num;
			numeric=true;
		}
		else
		{
			if(num==10) //delete last digit
				val=Math.floor(itemIPvalue[curItem][curPos]/10);
			else
				val=itemIPvalue[curItem][curPos]*10+num;
		}

		if(curItem<lastItemIdx)
		{
			if(val>=0 && val<=255)
			{
				itemIPvalue[curItem][curPos]=val;
				itemIP[curItem][curPos].setText(host.sprintf("%3d", val));
				itemLabel[curItem].setText(netSetupTitles[curItem]+' *');
			}
		}
		else
		{
			if(val>=0 && val<=9)
			{
				itemIPvalue[curItem][curPos]=val;
				itemIP[curItem][curPos].setText(host.sprintf("%3d", val));
				if(itemIPvalue[curItem][0]==0 && itemIPvalue[curItem][1]==0 && itemIPvalue[curItem][2]==0 && itemIPvalue[curItem][3]==0)
					itemLabel[curItem].setText(netSetupTitles[curItem]);
				else
					itemLabel[curItem].setText(netSetupTitles[curItem]+' *');
			}
		}
	}
}
